#!/usr/bin/env python

# parse_ping1.py
# Parse Nmap Portscan
# by Javantea aka. Joel R. Voss
# Nov 11-13, 2005

"""
3 students/room
50 rooms/floor
11 floors/building
6 buildings

3*50*11*6
9900 students
3*50*11*6*30/60
4950 minutes
3*50*11*6*30/3600
82.5 hours

"""

from xml.dom.minidom import parse
import MySQLdb

verbose = False
mysql = True

def parse_host2(host, output_file_prefix, conn = None):
	status = 'unknown'
	address = 'unknown'
	for info in host.childNodes:
		if info.nodeType == info.ELEMENT_NODE:
			if info.tagName == 'status':
				status = info.getAttribute('state')
				#print 'status', status
			elif info.tagName == 'address':
				if info.getAttribute('addrtype') == 'ipv4':
					address = info.getAttribute('addr')
				else:
					pass
				#end if
				#print 'address', address
			elif info.tagName == 'ports':
				parse_ports1(address, info, conn)
			#end if
		#end if
	#next info
	# We have the info, so we can now use it.
	#if verbose:
	print '#', address, 'is', status
	#elif status == 'up':
	#	print 'nmap -sS -P0 -T2 -p', ports, '-oX', output_file_prefix + address + '.xml', address
	#end if
#end def parse_host1(host)

def parse_ports1(host, ports, conn = None):
	a = 'unknown'
	b = 'unknown'
	for port in ports.childNodes:
		if port.nodeType == port.ELEMENT_NODE:
			if port.tagName == 'port':
				parse_port1(host, port, conn)
			#end if
		#end if
	#next port
#end def parse_host1(host)

def parse_port1(host, port, conn = None):
	portid = port.getAttribute('portid')
	for state in port.childNodes:
		if state.nodeType == state.ELEMENT_NODE:
			if state.tagName == 'state':
				port_state = state.getAttribute('state')
			#end if
		#end if
	#next state
	print 'portid', portid, 'is', port_state
	if mysql:
		cursor = conn.cursor()
		cursor.execute("INSERT INTO port (portid, state, host, ip) VALUES (" + portid + ", '" + port_state + "', 0, '" + host + "');")
	#end if
#end def parse_port1(port)

def parse_runstats1(runstats, conn = None):
	print '# stats'
	for stat in runstats.childNodes:
		if stat.nodeType == stat.ELEMENT_NODE:
			if stat.tagName == 'finished':
				print '# time =', stat.getAttribute('time')
			elif stat.tagName == 'hosts':
				print '# up =', stat.getAttribute('up')
			#end if
		#end if
	#next stat
#def parse_runstats1(runstats)

def parse_portscan1(input_file, output_file_prefix = 'ps'):
	dom1 = parse(input_file)
	
	conn = None
	if mysql:
		conn = MySQLdb.connect('localhost', 'inet', '', 'netmap1')
	#end if
	
	for host in dom1.documentElement.childNodes:
		if host.nodeType == host.ELEMENT_NODE:
			if host.tagName == 'host':
				parse_host2(host, output_file_prefix, conn)
			elif host.tagName == 'runstats':
				parse_runstats1(host, conn)
			#end if
		#end if
	#next host
#end def parse_portscan1(input_file, output_file_prefix)

def main():
	from sys import argv
	infile = 'port1_192.168.0.1.xml'
	if len(argv) > 1:
		infile = argv[1]
	#end if
	parse_portscan1(infile)
#end def main()

if __name__ == '__main__':
	main()
#end if
